/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 27 oct. 2006 13:36:21

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.fwkcktldepense.server.finder.FinderDepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOArticle;
import org.cocktail.fwkcktldepense.server.metier.EOCommande;
import org.cocktail.fwkcktldepense.server.metier.EOCommandeEngagement;
import org.cocktail.fwkcktldepense.server.metier.EOCommandeImpression;
import org.cocktail.fwkcktldepense.server.metier.EODepensePapier;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementBudget;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleAction;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleAnalytique;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleConvention;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControleHorsMarche;
import org.cocktail.fwkcktldepense.server.metier.EOEngagementControlePlanComptable;
import org.cocktail.fwkcktldepense.server.metier.b2b.EOB2bCxmlOrderRequest;
import org.cocktail.fwkcktlpersonne.common.metier.EOFournis;
import org.cocktail.fwkcktlpersonne.common.metier.IPersonne;
import org.cocktail.fwkcktlpersonne.common.metier.PersonneDelegate;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOResponse;
import com.webobjects.eocontrol.EOEditingContext;
import com.webobjects.eocontrol.EOGlobalID;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSMutableArray;
import com.webobjects.foundation.NSMutableDictionary;

import er.extensions.eof.ERXEC;

public class DetailCommande extends MyAjaxPage {
	private static final String PAGE_TITLE = "Détail d'une commande";
	private static final long serialVersionUID = 1L;
	public EOCommande laCommande = null;
	public String onloadJS = null;
	//	private NSArray<String> items = null;
	public boolean isRetourALaFacturePossible = false;
	public boolean isCommandeB2b = false;

	public EOArticle unArticle = null;
	public EOCommandeEngagement unEngagement = null;
	public EOEngagementControleHorsMarche unEngagementControleHorsMarche = null;
	public EOEngagementControleAction unEngagementControleAction = null;
	public EOEngagementControlePlanComptable unEngagementControlePlanCo = null;
	public EOEngagementControleConvention unEngagementControleConvention = null;
	public EOEngagementControleAnalytique unEngagementControleAnalytique = null;

	private NSArray<EODepensePapier> lesDepensesPapier = null;
	public EODepensePapier selectedDepensePapier = null;
	public EOB2bCxmlOrderRequest unB2bCxmlOrderRequest = null;
	public EOCommandeImpression uneCommandeImpression = null;

	public DetailCommande(WOContext context) {
		super(context);
	}

	public NSArray<String> itemsMenu() {
		NSMutableArray<String> lesItems = new NSMutableArray<String>(new String[] {
				"ModifierUneCommande",
				"DupliquerUneCommande",
				"LiquiderUneCommande",
				"SolderUneCommande",
				"SupprimerUneCommande",
				"Informer",
				"ImprimerUneCommande",
				"Accueil",
				"RetourALaListe"
		});

		if (isRetourALaFacturePossible) {
			lesItems.set(lesItems.count() - 1, "RetourALaFacture");
		}

		if (isCommandeB2b) {
			lesItems.add(7, Menu.B2B_ENVOYER_UNE_COMMANDE_KEY);
		}

		return lesItems.immutableClone();
		//return items;
	}

	public void appendToResponse(WOResponse res, WOContext ctx) {
		super.appendToResponse(res, ctx);
	}

	public String getOnloadJS() {
		return onloadJS;
	}

	public void setOnloadJS(String onloadJS) {
		this.onloadJS = onloadJS;
	}

	public String titreInfosGenerales() {
		String titreInfosGenerales = "";
		EOCommande commande = getLaCommande();
		if (commande != null) {
			titreInfosGenerales += "Commande:  ";
			titreInfosGenerales += commande.exercice().exeExercice().intValue() + " - ";
			titreInfosGenerales += " N&deg;: " + commande.commNumero();
			if (commande.typeEtat() != null) {
				titreInfosGenerales += " &nbsp;&nbsp;Etat: " + commande.typeEtat().tyetLibelle();
			}
			if (commande.articles() != null) {
				titreInfosGenerales += " &nbsp;&nbsp;Total HT: " + commande.articles().valueForKeyPath("@sum.artPrixTotalHt");
				titreInfosGenerales += " &nbsp;&nbsp;Total TTC: " + commande.articles().valueForKeyPath("@sum.artPrixTotalTtc");

			}
		}
		return titreInfosGenerales;
	}

	public boolean isAfficherRepartCN() {
		boolean isAfficherRepartCN = true;
		EOCommande commande = getLaCommande();
		if (commande != null) {
			if (commande.isSurUnMarche()) {
				isAfficherRepartCN = false;
			}
		}
		return isAfficherRepartCN;
	}

	public WOComponent afficherEngagementDetaille() {
		DetailEngagementBudget nextPage = (DetailEngagementBudget) pageWithName("DetailEngagementBudget");
		EOEngagementBudget engagementBudget = getUnEngagement().engagementBudget();
		nextPage.setEngagementBudget(engagementBudget);
		session.setLEngagementBudgetEnCours(engagementBudget);
		return nextPage;
	}

	public WOActionResults onSelectFacture() {
		DetailFacture nextPage = (DetailFacture) pageWithName("DetailFacture");

		//EODepensePapier dp = getUneDepensePapier();
		EODepensePapier dp = selectedDepensePapier;
		EOGlobalID gid = dp.editingContext().globalIDForObject(dp);
		if (!gid.isTemporary()) {
			EOEditingContext newEdc = ERXEC.newEditingContext();
			dp = (EODepensePapier) newEdc.faultForGlobalID(dp.editingContext().globalIDForObject(dp), newEdc);
		}
		nextPage.setLaFacture(dp);
		session.setLaDepensePapierEnCours(dp);
		session.setLaCommandeEnCours(dp.commandeassociee());
		return nextPage;
	}

	public EOCommande getLaCommande() {
		return laCommande;
	}

	public void setLaCommande(EOCommande laCommande) {
		this.laCommande = laCommande;
		isCommandeB2b = laCommande.isCommandeB2b();
		lesDepensesPapier = null;
	}

	public EOArticle getUnArticle() {
		return unArticle;
	}

	public void setUnArticle(EOArticle unArticle) {
		this.unArticle = unArticle;
	}

	public EOCommandeEngagement getUnEngagement() {
		return unEngagement;
	}

	public void setUnEngagement(EOCommandeEngagement unEngagement) {
		this.unEngagement = unEngagement;
	}

	public NSArray<EODepensePapier> getLesDepensesPapier() {
		EOCommande commande = getLaCommande();
		if (commande != null && lesDepensesPapier == null) {
			NSMutableDictionary<String, Object> bindings = new NSMutableDictionary<String, Object>();
			bindings.setObjectForKey(commande, "commande");
			lesDepensesPapier = FinderDepensePapier.getDepensePapier(commande.editingContext(), bindings);
		}
		return lesDepensesPapier;
	}

	public void setLesDepensesPapier(NSArray<EODepensePapier> lesDepensesPapier) {
		this.lesDepensesPapier = lesDepensesPapier;
	}

	public EOEngagementControleAction getUnEngagementControleAction() {
		return unEngagementControleAction;
	}

	public void setUnEngagementControleAction(
			EOEngagementControleAction unEngagementControleAction) {
		this.unEngagementControleAction = unEngagementControleAction;
	}

	public EOEngagementControleAnalytique getUnEngagementControleAnalytique() {
		return unEngagementControleAnalytique;
	}

	public void setUnEngagementControleAnalytique(
			EOEngagementControleAnalytique unEngagementControleAnalytique) {
		this.unEngagementControleAnalytique = unEngagementControleAnalytique;
	}

	public EOEngagementControleConvention getUnEngagementControleConvention() {
		return unEngagementControleConvention;
	}

	public void setUnEngagementControleConvention(
			EOEngagementControleConvention unEngagementControleConvention) {
		this.unEngagementControleConvention = unEngagementControleConvention;
	}

	public EOEngagementControleHorsMarche getUnEngagementControleHorsMarche() {
		return unEngagementControleHorsMarche;
	}

	public void setUnEngagementControleHorsMarche(
			EOEngagementControleHorsMarche unEngagementControleHorsMarche) {
		this.unEngagementControleHorsMarche = unEngagementControleHorsMarche;
	}

	public EOEngagementControlePlanComptable getUnEngagementControlePlanCo() {
		return unEngagementControlePlanCo;
	}

	public void setUnEngagementControlePlanCo(
			EOEngagementControlePlanComptable unEngagementControlePlanCo) {
		this.unEngagementControlePlanCo = unEngagementControlePlanCo;
	}

	public EOCommandeImpression getUneCommandeImpression() {
		return uneCommandeImpression;
	}

	public void setUneCommandeImpression(EOCommandeImpression uneCommandeImpression) {
		this.uneCommandeImpression = uneCommandeImpression;
	}

	public boolean isRetourALaFacturePossible() {
		return isRetourALaFacturePossible;
	}

	public void setRetourALaFacturePossible(boolean isRetourALaFacturePossible) {
		this.isRetourALaFacturePossible = isRetourALaFacturePossible;
	}

	public String orderRequestUtilisateur() {
		if (unB2bCxmlOrderRequest.persIdCreation() != null) {
			IPersonne pers = PersonneDelegate.fetchPersonneByPersId(edc(), unB2bCxmlOrderRequest.persIdCreation());
			if (pers != null) {
				return pers.getNomPrenomAffichage();
			}
		}
		return "nc";
	}

	public String preLiquidationTabTitle() {
		int nb = 0;
		NSArray<EODepensePapier> res = getLesDepensesPapier();
		for (int i = 0; i < res.count(); i++) {
			EODepensePapier dpp = res.objectAtIndex(i);
			if (dpp.isPreLiquidation()) {
				nb++;
			}
		}
		return "Pré-Liquidations (" + nb + ")";
	}

	public String liquidationTabTitle() {
		int nb = 0;
		NSArray<EODepensePapier> res = getLesDepensesPapier();
		for (int i = 0; i < res.count(); i++) {
			EODepensePapier dpp = res.objectAtIndex(i);
			if (!dpp.isPreLiquidation()) {
				nb++;
			}
		}
		return "Liquidations (" + nb + ")";
	}

	public Boolean isServiceFacturierDispo() {
		return session.isServiceFacturierDisponible();
	}

	public String pageTitle() {
		return PAGE_TITLE;
	}

	public String origineCommande() {
		if (getLaCommande() != null && getLaCommande().commandeEngagements().count() > 0) {
			return getLaCommande().commandeEngagements().objectAtIndex(0).engagementBudget().typeApplication().tyapLibelle();
		}
		return "nc";
	}

	public EOFournis getFournis() {
		if (getLaCommande() == null) {
			return null;
		}
		EOFournis fournis = EOFournis.fetchByKeyValue(getLaCommande().fournisseur().editingContext(), EOFournis.FOU_ORDRE_KEY, getLaCommande().fournisseur().fouOrdre());
		return fournis;
	}
}